#define LOOPDEV "/dev/loop"

/* ioctls, only I_STR ioctls are supported */
#define LOOP_I_BASE (('l' << 24) | ('o' << 16) | ('p' << 8))

#define LOOP_I_GETSTAT	(LOOP_I_BASE | 1)	/* get statistics	*/

/* for LOOP_I_GETSTAT */
struct loop_statistics {
	unsigned	num_msg;	/* number of messages		*/
	unsigned	num_allocb;	/* number of allocb calls	*/
	unsigned	num_nomem;	/* number of no mem errors	*/
	unsigned	q_count;	/* copy of read q->q_count	*/
	unsigned	q_mblkcnt;	/* copy of read q->q_mblkcnt	*/
};

/* putmsg/getmsg ctl struct */
struct loop_ctl {
	int cmd;	/* values: LOOP_C_*	*/
	int error;	/* 0 if ok		*/
};

/* Get status via putmsg/getmsg. struct loop_statistics in data part */
#define LOOP_C_STAT 's'
