/* 
 * Testprogram for spy module. It opens a tcp connection to the local echo port
 * and pushes the spy module on the protocol stack.
 *
 * usage: spytst [nloops]
 */

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <errno.h>
#include <time.h>
#include <unistd.h>
#include <stropts.h>
#include <sys/conf.h>

void Error(char *str, ...);

int
main(int argc, char **argv)
{
	int sd;
	struct sockaddr_in srv_addr;
	struct hostent *host;
	int n, l;
	int nloops = 4;
	char buf[200], *p;
	char *hostname = "localhost";
	char *portname = "7"; /* echo */

	if (argc >= 2)
		nloops = atoi(argv[1]);

	/* Umwandeln des hostnamens in eine Adresse */
	if ((host = gethostbyname(hostname)) == NULL)
		Error("gethostbyname");

	/* socket adress structur mit Hostadresse versorgen */
	memset(&srv_addr, 0, sizeof(srv_addr));
	memcpy((char *) &srv_addr.sin_addr, host->h_addr, host->h_length);
	srv_addr.sin_family = AF_INET;
	srv_addr.sin_port = htons(atoi(portname));

	/* socket oeffnen */
	if ((sd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
		Error("socket");
	
	/* push spy module */
	if (ioctl(sd, I_PUSH, "spy") < 0)
		Error("ioctl(I_PUSH)");

	/* duplicate sd to str input and call strconf to list modules */
	close(0);
	if (dup2(sd, 0) != 0)
		Error("dup2");
	printf("modules:\n");
	system("strconf");
	printf("\n");

	/* Verbindungsaufnahme mit server */
	if (connect(sd, (struct sockaddr *)&srv_addr, sizeof(srv_addr)))
		Error("connect");

	/* gut zum Ansehen der stehenden Verbindung mit netstat */
	if (nloops < 0)
		sleep(1000000);

	/* nloops Nachrichten an Server schicken und Antwort lesen */
	for (n = 0; n < nloops; ++n) {
		/* \0 terminierte Nachricht zusammenstellen und senden */
		sprintf(buf, "[%d] client %d time %d", n, getpid(), 
			time(NULL));
		l = strlen(buf) + 1;
		if (write(sd, buf, l) != l)
			Error("write, l = %d", l);
		
		/* Antwort lesen bis \0 empfangen */
		p = buf;
		do {
			if (p >= buf + sizeof(buf))
				Error("read buffer overflow");
			l = read(sd, p, buf + sizeof(buf) - p);
			if (l <= 0)
				Error("read");
			p += l;
		} while (*(p-1) != '\0');       /* read until \0 */
		printf("*** %s\n", buf);
	}

	/* Verbindung zu Server schliessen, verursacht bei Server EOF */
	close(sd);
}


void
Error(char *str, ...)
{
        va_list ap;

        va_start(ap, str);
        vfprintf(stderr, str, ap);
        va_end(ap);
        fprintf( stderr, "\n" );
        if (errno)
                fprintf(stderr, "   errno %d: %s\n",
                        errno, strerror(errno));

        exit(1);
}
